import React, { useContext, useEffect, useMemo, useState } from 'react'
import { Input, Select, message } from 'antd'
import { LoadTableFields, ReloadTableFields } from '../../../../../apis/process'

const FieldNames = (props) => {

  let fieldsStr = window.sessionStorage.getItem('designerRef') || ''
  let fields = fieldsStr.split(',') || []
  const { value, onChange, addons } = props
  const { tableNameParent, widget } = addons.formData
  const [fieldName, setFieldName] = useState([])

  const options = useMemo(() => {
    if (widget === 'RelevanceSelect' && addons.dataPath === 'fieldParent') {
      return fieldName
    }
    return fieldName.filter(v => !fields.includes(v.name))
  }, [fieldName, addons])

  const selectChange = (value) => {
    if (widget !== 'RelationForm') {
      addons.setValueByPath('title', value)
    } else {
      addons.setValueByPath('titleShow', value)
    }
    onChange(value)
  }

  const onFocus = async () => {
    if (!tableNameParent) {
      return message.info('缺少表名!')
    }
    const { data } = await ReloadTableFields({ tableName: tableNameParent })
    if (Array.isArray(data.root)) {
      setFieldName(data.root)
    }
  }

  useEffect(() => {
    if (value && value.includes('#/')) {
      let array = value.split('/')
      if (array.length === 3) {
        onChange(array[2])
      } else if (array.length === 2) {
        onChange(array[1])
      }
    }
  }, [value])

  return (
    <Select
      onFocus={onFocus}
      onChange={selectChange}
      style={{ width: '100%', maxWidth: '222px' }}
      showSearch
      optionFilterProp='children'
      value={value}
      fieldNames={{ label: 'name', value: 'name' }}
      options={options}
    >
    </Select>
  )
}

export default FieldNames