import React, { useState, useEffect, useMemo } from 'react'
import { Input } from 'antd'

const TextArea = ({ value, onChange, schema }) => {

  const { disabled, placeholder, presetValue, maxLength, rows } = schema

  useEffect(() => {
    onChange(presetValue)
  }, [presetValue])

  const handleChange = (e) => {
    onChange(e.target.value)
  }

  return (
    <Input.TextArea
      maxLength={maxLength}
      disabled={disabled}
      value={value}
      rows={rows}
      placeholder={placeholder}
      onChange={handleChange}
    />
  )
}

export default TextArea
